"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const constants_1 = require("./constants");
exports.default = {
    // Directory to store assets temporarily.
    assetsRoot: path_1.default.join(constants_1.TUTURE_ROOT, 'assets'),
    // Time interval to synchronize all assets.
    assetsSyncInterval: 10000,
    // Path to build outputs.
    buildPath: path_1.default.join(constants_1.TUTURE_ROOT, 'build'),
    // Port to use for tuture-server.
    port: 3013,
    // Files that should be commited but won't be tracked by Tuture.
    ignoredFiles: [
        // Git-related files
        '.gitignore',
        '.gitattributes',
        // Tuture-related files
        '.tuturerc',
        '.tutureignore',
    ],
};
